class BookmarksBuilder < Builder
  # def self.build(collections = [])
  #   super(subject_repository, collections, true, 'rid')
  # end

  def self.build_from_orientdb(args = {})
    super(args) do
      learning_objects = args['learning_objects'].nil? ? [] : LearningObjectBuilder.build(map_rid_to_object(args['learning_objects']))
      obj = Bookmarks.new(
        learning_objects: learning_objects,
        privacy: args['privacy'],
        id: args['@rid'],
      )
      obj.owner = collection_repository.owner(args['@rid'])
      obj.created_at = DateTime.strptime(args['created_at'], "%Y-%m-%d %H:%M:%S") unless args['created_at'].nil?
      obj.last_modified = DateTime.strptime(args['last_modified'], "%Y-%m-%d %H:%M:%S") unless args['last_modified'].nil?
      obj
    end
  end

  def self.map_rid_to_object(ids)
    return {'rid' => ids} if ids.class == String

    ids.map do |id|
      {'rid' => id}
    end
  end
end
