class Builder
  extend RepositoriesProxy

  protected

  def self.build(repository, objects = [], cache = true, id = '@rid', last_modified = 'last_modified')
    array = []
    objects = [objects] if objects.class == String || objects.class == Hash
    objects.each do |object|
      next if object[id].blank?

      if cache && !object[last_modified].blank?
        o = Rails.cache.fetch(cache_key(object[id], object[last_modified]))
      end

      o = repository.find object[id] if o.nil?
      array << o
    end
    array
  end

  def self.build_from_orientdb(args = {})
    object = nil

    unless args.nil? || !block_given?
      # cache object when build
      object = Rails.cache.fetch(cache_key(args['@rid'], args['last_modified']), expires_in: 12.hours) { yield }
    end

    object
  end

  def self.cache_key(rid, last_modified)
    last_modified = Time.at(0).to_s if last_modified.nil?

    rid + '/' + last_modified
  end

end
