module OrientDb
  module Associations
    class PublisherAssociation < OrientDb::Association

      def can_create?
        !@object.publisher.nil? && !edge_exists?("PublishedBy", @object.id, @object.publisher.id)
      end

      protected

      def execute
        if @learning_object.publisher.class.name == "User"
          create_edge("PublishedBy", @object.id, @object.publisher.rid)
        else
          create_edge("PublishedBy", @object.id, @object.publisher.id)
        end
      end

    end
  end
end
